package com.yunos.cmns.sdkdemo;

import android.app.Application;
import android.content.Context;
import android.os.Handler;
import android.util.Log;
import android.widget.Toast;

import com.yunos.push.PushClient;
import com.yunos.push.api.PushMessage;
import com.yunos.push.api.listener.PushAsyncInitListener;
import com.yunos.push.api.listener.PushMessageListener;


/**
 * Created by sjjwind on 09/02/17.
 */
public class MyApplication extends Application {
    private static final String TAG = "PushDemo Application";
    private Handler mHandler = new Handler();

    @Override
    public void onCreate() {
        super.onCreate();
        Log.d(TAG, "MyApplication onCreate");
        NetworkPermissionConfig.getInstance().setContext(this.getApplicationContext());
        NetworkPermissionConfig.getInstance().setObserver(new NetworkPermissionConfig.NetworkPermissionListener() {
            @Override
            public void onPermit() {
                Log.d(TAG, "permission");
                PushClient.getInstance().init(MyApplication.this.getApplicationContext(), new PushAsyncInitListener() {
                    @Override
                    public void onInit(int errorCode) {
                        Log.d(TAG, "init success");
                    }
                });
            }
        });

        PushClient.getInstance().setMessageListener(new PushMessageListener() {
            @Override
            public void onPassThroughMessage(Context context, final PushMessage pushMessage) {
                Log.d(TAG, "onPassThroughMessage");
                mHandler.post(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(MyApplication.this, "pass mid: " + pushMessage.getMessageId() + "\nmsg: " + pushMessage.getPayload(), Toast.LENGTH_SHORT).show();
                    }
                });
            }

            @Override
            public void onNotificationClicked(Context context, final PushMessage pushMessage) {
                Log.d(TAG, "onNotificationClicked");
                mHandler.post(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(MyApplication.this, "notification mid: " + pushMessage.getMessageId() + "\nmsg: " + pushMessage.getPayload(), Toast.LENGTH_SHORT).show();
                    }
                });
            }
        });
    }
}
