package com.yunos.cmns.sdkdemo;

import android.content.Context;
import android.content.SharedPreferences;

/**
 * Created by sjjwind on 06/07/17.
 */
public class NetworkPermissionConfig {
    private static NetworkPermissionConfig sInstance;
    private NetworkPermissionListener mListener = null;

    public interface NetworkPermissionListener {
        void onPermit();
    }

    public static NetworkPermissionConfig getInstance() {
        if (sInstance == null) {
            synchronized (NetworkPermissionConfig.class) {
                sInstance = new NetworkPermissionConfig();
            }
        }
        return sInstance;
    }

    private Context mAppContext;
    public void setContext(Context appContext) {
        mAppContext = appContext;
    }

    public void setObserver(NetworkPermissionListener listener) {
        mListener = listener;
        if (getUserPermission()) {
            if (mListener != null) {
                mListener.onPermit();
            }
        }
    }

    public void singal() {
        writeSingal();
        if (mListener != null) {
            mListener.onPermit();
        }
    }

    public boolean getUserPermission() {
        SharedPreferences settings = mAppContext.getSharedPreferences("setting", 0);
        return settings.getBoolean("network_permission", false);
    }

    public void writeSingal() {
        SharedPreferences settings = mAppContext.getSharedPreferences("setting", 0);
        SharedPreferences.Editor editor = settings.edit();
        editor.putBoolean("network_permission", true);
        editor.commit();
    }
}
